import var CommonCrypto.CC_MD5_DIGEST_LENGTH
import func CommonCrypto.CC_MD5
import typealias CommonCrypto.CC_LONG

import Foundation

extension String {
    
    var md5: String {
        let data = Data(self.utf8)
        let hash = data.withUnsafeBytes { (bytes: UnsafeRawBufferPointer) -> [UInt8] in
            var hash = [UInt8](repeating: 0, count: Int(CC_MD5_DIGEST_LENGTH))
            CC_MD5(bytes.baseAddress, CC_LONG(data.count), &hash)
            return hash
        }
        return hash.map { String(format: "%02x", $0) }.joined()
    }
    
}

print("".md5)
print("".md5)
print("test".md5)


var now = Date()
var future = Calendar.current.date(byAdding: .second, value: 5, to: now)

print((future!.compare(now)).rawValue)
print((now.compare(future!)).rawValue)
print((now.compare(now)).rawValue)
